 addHook("PlayerThink", function(player)
	if player.charability == CA_FLY and player.panim == PA_ABILITY
		player.powers[pw_tailsfly] = 999999
	end
	if player.powers[pw_tailsfly] and player.pflags & PF_JUMPDOWN
		player.fly1 = 1
	end
	if (player.cmd.forwardmove > 0 or player.cmd.forwardmove < 0 or player.cmd.sidemove > 0 or player.cmd.sidemove < 0) and not (player.pflags & PF_SPINNING)
		player.mo.friction = FRACUNIT
	end
	if not (player.cmd.forwardmove > 0 or player.cmd.forwardmove < 0 or player.cmd.sidemove > 0 or player.cmd.sidemove < 0) and not (player.pflags & PF_SPINNING)
		player.mo.friction = 9*FRACUNIT/10
	end
	if player.speed > 72*FRACUNIT and not (player.powers[pw_sneakers] or player.powers[pw_super])
		player.mo.friction = 9*FRACUNIT/10
	end
	if player.speed > 120*FRACUNIT and (player.powers[pw_sneakers] or player.powers[pw_super])
		player.mo.friction = 9*FRACUNIT/10
	end
	if player.charflags & SF_DASHMODE and player.mo.eflags & MFE_UNDERWATER
		player.charflags = $ & ~SF_DASHMODE
	else
		player.charflags = $ | SF_DASHMODE
	end
	if player.charability == CA_JUMPTHOK and not (player.mo.eflags & MFE_UNDERWATER)
		player.actionspd = player.speed
	end
	if player.charability == CA_JUMPTHOK and player.mo.eflags & MFE_UNDERWATER
		player.actionspd = player.speed*2
	end
	if not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.charability == CA_JUMPTHOK and player.actionspd > 72*FRACUNIT
		player.actionspd = 72*FRACUNIT
	end
	if (player.powers[pw_sneakers] or player.powers[pw_super]) and player.charability == CA_JUMPTHOK and player.actionspd > 120*FRACUNIT
		player.actionspd = 120*FRACUNIT
	end
	if player.charability == CA_JUMPTHOK and player.pflags & PF_THOKKED and not (player.pflags & PF_SHIELDABILITY)
		player.pflags = $ | PF_JUMPED
		player.pflags = $ | PF_SPINNING
		player.pflags = $ & ~PF_NOJUMPDAMAGE
	end
	if (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.pflags & PF_STARTDASH
		player.mindash = 60*FRACUNIT
		player.maxdash = 120*FRACUNIT
	end
	if not (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.pflags & PF_STARTDASH
		player.mindash = 36*FRACUNIT
		player.maxdash = 72*FRACUNIT
	end
	if (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.pflags & PF_STARTDASH
		player.mindash = 30*FRACUNIT
		player.maxdash = 120*FRACUNIT
	end
	if not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.pflags & PF_STARTDASH
		player.mindash = 18*FRACUNIT
		player.maxdash = 72*FRACUNIT
	end
	if player.charability == CA_FLY and player.panim == PA_ABILITY and (player.pflags & PF_USEDOWN and player.pflags & PF_JUMPDOWN)
		player.mo.state = S_PLAY_JUMP
		player.pflags = $ | PF_JUMPED
		player.pflags = $ & ~PF_THOKKED
	end
	if player.charability == CA_TWINSPIN and not (player.pflags & PF_STARTDASH or player.pflags & PF_SPINNING)
		player.charability2 = CA2_MELEE
		player.mindash = 2*FRACUNIT
		player.maxdash = 2*FRACUNIT
	end
	if player.mo.state == S_PLAY_MELEE_LANDING
		player.mo.friction = FRACUNIT
		if player.speed > 0 then
			player.mo.state = S_PLAY_WALK
		end
		if player.speed == 0 then
			player.mo.state = S_PLAY_STND
		end
		if player.pflags & PF_USEDOWN and not (player.pflags & PF_JUMPDOWN) and player.speed >= 5*FRACUNIT
			player.mo.state = S_PLAY_ROLL
			player.pflags = $ | PF_SPINNING
			S_StartSound(player.mo, sfx_spin)
		end
		if player.pflags & PF_USEDOWN and not (player.pflags & PF_JUMPDOWN) and player.speed < 5*FRACUNIT
			player.charability2 = CA2_SPINDASH
			player.mo.state = S_PLAY_SPINDASH
			player.pflags = $ | PF_SPINNING
			player.pflags = $ | PF_STARTDASH
			S_StartSound(player.mo, sfx_spndsh)
		end
		if player.pflags & PF_JUMPDOWN and not (player.pflags & PF_USEDOWN)
			player.mo.state = S_PLAY_ROLL
			player.pflags = $ | PF_STARTJUMP
			player.pflags = $ | PF_JUMPED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
			S_StartSound(player.mo, sfx_jump)
			if not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and not (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, (39*player.jumpfactor)/4, false)
			end
			if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and not (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, 18*player.jumpfactor, false)
			end
			if not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and player.mo.eflags & MFE_UNDERWATER
				P_SetObjectMomZ(player.mo, (23*player.jumpfactor)/4, false)
			end
			if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and player.mo.eflags & MFE_UNDERWATER
				P_SetObjectMomZ(player.mo, (21*player.jumpfactor)/2, false)
			end
		end
	end
	if player.charability == CA_TWINSPIN and (player.pflags & PF_SPINNING or player.panim == PA_ROLL)
		player.charflags = $ & ~SF_NOJUMPSPIN
		player.charflags = $ & ~SF_NOJUMPDAMAGE
	end
	if player.charability == CA_TWINSPIN and (not (player.pflags & PF_SPINNING) or player.panim != PA_ROLL)
		player.charflags = $ | SF_NOJUMPSPIN
		player.charflags = $ | SF_NOJUMPDAMAGE
	end
	if player.charability == CA_TWINSPIN and player.mo.eflags & MFE_JUSTHITFLOOR and player.pflags & PF_USEDOWN and player.speed >= 5*FRACUNIT and (player.pflags & PF_SPINNING or player.panim == PA_ROLL)
		player.mo.state = S_PLAY_ROLL
		player.pflags = $ | PF_SPINNING
		S_StartSound(player.mo, sfx_spin)
	end
	if (player.mo.state == S_PLAY_FIRE or player.mo.state == S_PLAY_FIRE_FINISH or player.airgun == true) and player.weapondelay
		player.mo.momx = player.lastmomx
		player.mo.momy = player.lastmomy
	end
	if (player.mo.state == S_PLAY_FIRE or player.mo.state == S_PLAY_FIRE_FINISH) and not player.weapondelay
		if player.speed > 0 then
			player.mo.state = S_PLAY_WALK
			player.mo.momx = player.lastmomx
			player.mo.momy = player.lastmomy
		end
		if player.speed == 0 then
			player.mo.state = S_PLAY_STND
		end
	end
	if player.airgun == true and player.weapondelay
		player.mo.momx = player.lastmomx
		player.mo.momy = player.lastmomy
	end
	if player.airgun == true and not player.weapondelay and not (player.pflags & PF_BOUNCING)
		player.mo.state = S_PLAY_JUMP
		player.pflags = $ | PF_JUMPED
		player.pflags = $ | PF_NOJUMPDAMAGE
		player.pflags = $ & ~PF_THOKKED
		player.pflags = $ & ~PF_USEDOWN
	end
	if not P_IsObjectOnGround(player.mo) and (player.panim == PA_WALK or player.panim == PA_RUN or (player.panim == PA_DASH and not (player.pflags & PF_THOKKED)) or player.panim == PA_SPRING or player.panim == PA_FALL or (player.charflags & SF_NOJUMPSPIN and player.panim == PA_JUMP)) and not ((player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN) and player.pflags & PF_THOKKED) and not (not (player.pflags & PF_BOUNCING) and player.bouncelast) and not player.glidelast and not (player.charability == CA_FLOAT and player.pflags & PF_THOKKED and (player.panim == PA_FALL or player.panim == PA_SPRING) and not (player.pflags & PF_SHIELDABILITY))
		if player.mo.momz > 0 and not (player.mo.eflags & MFE_VERTICALFLIP)
			player.mo.state = S_PLAY_SPRING
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
		if player.mo.momz <= 0 and not (player.mo.eflags & MFE_VERTICALFLIP)
			player.mo.state = S_PLAY_FALL
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
		if player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
			player.mo.state = S_PLAY_SPRING
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
		if player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz >= 0
			player.mo.state = S_PLAY_FALL
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
	end
	if player.pflags & PF_SHIELDABILITY
		if player.panim != PA_ROLL
			player.mo.state = S_PLAY_ROLL
		end
		player.pflags = $ | PF_JUMPED
		player.pflags = $ & ~PF_NOJUMPDAMAGE
		if player.mo.eflags & MFE_JUSTHITFLOOR and player.pflags & PF_USEDOWN and player.panim == PA_ROLL
			S_StartSound(player.mo, sfx_spin)
		end
	end
--Glide & Bounce Momentum Code originally made by Frostiikin
	if player.charability == CA_GLIDEANDCLIMB
		if player.glidelast == nil
			player.glidelast = 0
		end
		local gliding = player.pflags & PF_GLIDING
		local thokked = player.pflags & PF_THOKKED
		local exitglide = (player.glidelast == 1 and not (gliding) and thokked)
		local landglide = (player.glidelast == 2 and not (gliding|thokked))
		if exitglide or landglide
			player.mo.momx = player.lastmomx
			player.mo.momy = player.lastmomy
		end
		if exitglide and player.panim != PA_JUMP
			player.mo.state = S_PLAY_JUMP
			player.pflags = $ | PF_JUMPED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
		if gliding
			player.glidelast = 1
		elseif exitglide
			player.glidelast = 2
		elseif not(gliding|thokked)
			player.glidelast = 0
		end
	end
	if player.charability == CA_BOUNCE
		if player.bouncelast == nil
			player.bouncelast = false
		end
		if player.pflags & PF_BOUNCING and not (player.bouncelast) and player.panim != PA_PAIN
		or (not (player.pflags & PF_BOUNCING) and player.bouncelast) and player.panim != PA_PAIN
			player.mo.momx = player.lastmomx
			player.mo.momy = player.lastmomy
			if (not (player.pflags & PF_BOUNCING) and player.bouncelast)
				player.mo.state = S_PLAY_JUMP
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
		end
		player.bouncelast = (player.pflags & PF_BOUNCING > 0)
	end
	player.lastmomx = player.mo.momx
	player.lastmomy = player.mo.momy
end)
-- Repurposed Spam Dash Code originally made by Starlight
local function Uncurl(player)
	if (player.speed > 5*FRACUNIT and player.pflags & PF_STARTDASH) then return true end
	if P_IsObjectOnGround(player.mo) and player.pflags & PF_SPINNING and player.mo.state == S_PLAY_ROLL and not (player.pflags & (PF_USEDOWN|PF_STARTDASH)) then
		player.mo.state = S_PLAY_WALK
		player.pflags = ($ & ~PF_SPINNING) | PF_USEDOWN
		return true
    end
end
addHook("SpinSpecial", Uncurl)
--Repurposed Egg Reverie Flight Code by Fyrid19
local p = player
local frac = FRACUNIT
freeslot("sfx_boost")
addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and (p.mo.skin == "metalsonic")) then return end
		if not (p.cmd.buttons & BT_JUMP) then -- flight button press
			p.c1ready = true
			p.c1 = false
		elseif p.c1ready then
			p.c1 = true
			p.c1ready = false
		else
			p.c1 = false
		end
		if not (p.cmd.buttons & BT_USE) then -- boost button press
			p.c2ready = true
			p.c2 = false
		elseif p.c2ready then
			p.c2 = true
			p.c2ready = false
		else
			p.c2 = false
		end
		if (p.powers[pw_super] or p.mo.skin == "metalsonic")
			if p.flying and p.cmd.buttons & BT_USE and p.cmd.buttons & BT_JUMP and (p.secondjump == 1 or p.secondjump == 2)
				p.flying = false
				p.mo.state = S_PLAY_JUMP
				p.pflags = $ | PF_JUMPED
				p.pflags = $ & ~PF_THOKKED
				p.pflags = $ & ~PF_NOJUMPDAMAGE
				p.secondjump = 0
			elseif not p.flying and not P_IsObjectOnGround(p.mo) and p.pflags & PF_THOKKED and p.c1
				p.flying = true
			end
		end
		if not (p.powers[pw_super] or p.mo.skin == "metalsonic")
		and p.flying
			p.flying = false
		end
		if p.flying == nil
			p.flying = false
		end
		if P_IsObjectOnGround(p.mo)
			p.flying = false
		end
		if p.flying and (p.secondjump == 1 or p.secondjump == 2)
			if (p.cmd.buttons & BT_JUMP) and not (p.cmd.buttons & BT_USE)
				if p.mo.momz <= 10*FRACUNIT
					p.mo.momz = p.mo.momz + 2*FRACUNIT
				end
			elseif (p.cmd.buttons & BT_USE) and not (p.cmd.buttons & BT_JUMP)
				if p.mo.momz >= -10*FRACUNIT
					p.mo.momz = p.mo.momz - 2*FRACUNIT
				end
			else
				if p.mo.momz >= 2*FRACUNIT
					p.mo.momz = p.mo.momz - 2*FRACUNIT
				elseif p.mo.momz <= -2*FRACUNIT
					p.mo.momz = p.mo.momz + 2*FRACUNIT
				elseif p.mo.momz > -2*FRACUNIT and p.mo.momz < 2*FRACUNIT
					p.mo.momz = 0
				end
			end
			if p.dashmode < 3*TICRATE
				p.pflags = $ | PF_NOJUMPDAMAGE
			end
			if p.dashmode >= 3*TICRATE
				p.pflags = $ & ~PF_NOJUMPDAMAGE
			end
			if (p.mo.skin == "metalsonic")
				if p.speed >= p.runspeed and (p.dashmode < 3*TICRATE or p.mo.skin != "metalsonic")
					p.mo.state = S_PLAY_FLOAT_RUN
				end
				if p.speed >= p.runspeed and p.dashmode >= 3*TICRATE and p.mo.skin == "metalsonic"
					p.mo.state = S_PLAY_DASH
				end
				if p.speed < p.runspeed
					p.mo.state = S_PLAY_FLOAT
				end
			end
			p.pflags = $|PF_JUMPED|PF_THOKKED
		end
	end
end)