--Repurposed Air Options by MasterDisaster64
local function RefreshAbility(player)
	player.pflags = $ | PF_JUMPED & ~PF_THOKKED
	player.secondjump = 0;
end

local function SpinCharThink(player)
    -- Ignore if character is grounded
    if (P_IsObjectOnGround(player.mo))
    player.mo.ao_donecheck = false
    return
end
    -- If spinning in the air
    if (player.pflags & PF_SPINNING)
        -- Turn off the spinning flag; this means you won't turn slowly like when rolling on ground
        player.pflags = $ & ~PF_SPINNING
        -- Use the jump state instead
		if player.charability == CA_TWINSPIN
			player.mo.state = S_PLAY_ROLL
			player.pflags = $ & ~PF_THOKKED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
			player.pflags = $ | PF_JUMPED
		end
		if player.charability != CA_TWINSPIN and player.panim != PA_JUMP
			player.mo.state = S_PLAY_JUMP
			player.pflags = $ & ~PF_THOKKED
			player.pflags = $ | PF_JUMPED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
		end
        -- Enable air ability
        player.mo.ao_donecheck = true
    end

    if (player.mo.ao_donecheck and not player.mo.coyoteTime)
        player.mo.ao_donecheck = false
        if player.charability != CA_JUMPTHOK
			RefreshAbility(player)
		end
    end
end

addHook("PreThinkFrame", function()
	for player in players.iterate do
		SpinCharThink(player);
	end
end);